#include <sys/types.h> 
#include <unistd.h> 
#include <stdio.h>
#include <stdlib.h>
#define N 5

int main()
{
int pid;
int pd[2];
int vett[N];

if (pipe(pd)==-1)
{ printf ("Errore nella pipe\n"); exit(1);}

pid=fork();

if (pid==-1)
	{printf ("Errore nella fork\n"); exit(1);}
// da questo punto in poi ci sono 2 processi padre e figlio
switch (pid){
case -1: printf ("Errore nella fork\n");exit (1);break;
case 0: // codice figlio
	{int i; double media;
	read (pd[0],vett,sizeof(int)*N);
	printf ("\n\nFiglio: vett letto\n");
	media=0.0;
	for (i=0;i<N;i++)
		media+=vett [i];
	media/=N;
	write(pd[1], &media,sizeof(double));
	}
	break;
default:  // codice padre
	{int i,status; double media;
	for (i=0;i<N;i++){
		printf("Scrivi v[%d]>",i);
		scanf ("%d",&vett[i]);
	}
	write (pd[1],vett,sizeof(int)*N);
	//legge la media
	wait (&status);
	read (pd[0],&media,sizeof(double));
	printf ("Media letta %.2f\n",media);
	}  // fine default
}  //fine switch

return 0;
}
